#include <gtk/gtk.h>
#include <string.h>
#define GIIS_CONF_FILE  "./config/giis.conf"
//gcc -Wall -g -o giis_installation_wizard giis_installation_wizard.c `pkg-config --cflags --libs gtk+-2.0` -export-dynamic

static void assistant_cancel (GtkAssistant*, gpointer);
static void assistant_close (GtkAssistant*, gpointer);

typedef struct
{
    GtkWidget *widget;
    gint index;
    const gchar *title;
    GtkAssistantPageType type;
    gboolean complete;
} PageInfo;

GtkWidget *assistant, *entry, *label, *button, *progress, *hbox, *entry_1, *label_1, *entry_2, *label_2;
int main (int argc, 
          char *argv[])
{
  
  guint i;
  PageInfo page[5] = {
      { NULL, -1, "Setup - gET iT i saY . giis",           GTK_ASSISTANT_PAGE_INTRO,   TRUE},
      { NULL, -1, "Choose Directories",                     GTK_ASSISTANT_PAGE_CONTENT, TRUE},
      { NULL, -1, "Maximum Directory depth", GTK_ASSISTANT_PAGE_CONTENT, TRUE},
      { NULL, -1, "Auto Update time",       GTK_ASSISTANT_PAGE_PROGRESS, TRUE},
      { NULL, -1, "Start Installation",           GTK_ASSISTANT_PAGE_CONFIRM, TRUE},
  };

  gtk_init (&argc, &argv);

  /* Create a new assistant widget with no pages. */
  assistant = gtk_assistant_new ();
  gtk_widget_set_size_request (assistant, 550, 300);
  gtk_window_set_title (GTK_WINDOW (assistant), "	Setup Wizard");
 
  g_signal_connect (G_OBJECT (assistant), "destroy",
                    G_CALLBACK (gtk_main_quit), NULL);
  
  page[0].widget = gtk_label_new ("Welcome to the giis Setup Wizard.This will take\n"\
                                  "you through the installation of the giis software.\n\n\n" \
				   "Note : [*] denotes they are optional,You can ignore them." );
  page[1].widget = gtk_hbox_new (FALSE, 5);
  page[2].widget = gtk_hbox_new (FALSE, 5);
  page[3].widget = gtk_hbox_new (FALSE, 5);
  page[4].widget = gtk_label_new ("Make sure you have added (any) additional directories\n"\
                                  "and entered auto update time & maximum directory depth\n"\
                                  "It's time to start install!!!");
  
  /* Create the necessary widgets for the second page. */
  label = gtk_label_new ("[*]Enter additional  directories \n (Default directories:root,home)\n");
  entry = gtk_entry_new ();
  label_1 = gtk_label_new ("[*]Max. directory depth (Default:10)  \n");
  entry_1 = gtk_entry_new ();

  label_2 = gtk_label_new ("[*]Auto update time (Default:20 mints)  \n");
  entry_2 = gtk_entry_new ();

  
  gtk_box_pack_start (GTK_BOX (page[1].widget), label, FALSE, FALSE, 5);
  gtk_box_pack_start (GTK_BOX (page[1].widget), entry, FALSE, FALSE, 5);

  gtk_box_pack_start (GTK_BOX (page[2].widget), label_1, FALSE, FALSE, 5);
  gtk_box_pack_start (GTK_BOX (page[2].widget), entry_1, FALSE, FALSE, 5);

  gtk_box_pack_start (GTK_BOX (page[3].widget), label_2, FALSE, FALSE, 5);
  gtk_box_pack_start (GTK_BOX (page[3].widget), entry_2, FALSE, FALSE, 5);
  
  /* Create the necessary widgets for the fourth page. The, Attach the progress bar
   * to the GtkAlignment widget for later access.*/
  button = gtk_button_new_with_label ("Click me!");
  progress = gtk_progress_bar_new ();
  hbox = gtk_hbox_new (FALSE, 5);
  gtk_box_pack_start (GTK_BOX (hbox), progress, TRUE, FALSE, 5);
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, FALSE, 5);
  
  /* Add five pages to the GtkAssistant dialog. */
  for (i = 0; i < 5; i++)
  {
    page[i].index = gtk_assistant_append_page (GTK_ASSISTANT (assistant), 
                                               page[i].widget);
    gtk_assistant_set_page_title (GTK_ASSISTANT (assistant), 
                                  page[i].widget, page[i].title);
    gtk_assistant_set_page_type  (GTK_ASSISTANT (assistant), 
                                  page[i].widget, page[i].type);

    /* Set the introduction and conclusion pages as complete so they can be
     * incremented or closed. */
    gtk_assistant_set_page_complete (GTK_ASSISTANT (assistant), 
                                     page[i].widget, page[i].complete);
  }
  
  /* Update whether pages 2 through 4 are complete based upon whether there is
   * text in the GtkEntry, the check button is active, or the progress bar
   * is completely filled. */
                    
  g_signal_connect (G_OBJECT (assistant), "cancel",
                    G_CALLBACK (assistant_cancel), NULL);
  g_signal_connect (G_OBJECT (assistant), "close",
                    G_CALLBACK (assistant_close), NULL);

  gtk_widget_show_all (assistant);

  gtk_main ();
  return 0;
}


/* If the dialog is cancelled, delete it from memory and then clean up after
 * the Assistant structure. */
static void 
assistant_cancel (GtkAssistant *assistant, 
                  gpointer data)
{
  gtk_widget_destroy (GTK_WIDGET (assistant));
}

/* This function is where you would apply the changes and destroy the assistant. */
static void 
assistant_close (GtkAssistant *assistant, 
                 gpointer data)
{

  g_print ("You would apply your changes now!\n");
  
//get entered data
  const gchar *text = gtk_entry_get_text (GTK_ENTRY (entry));
  const gchar *text_1 = gtk_entry_get_text (GTK_ENTRY (entry_1));
  const gchar *text_2 = gtk_entry_get_text (GTK_ENTRY (entry_2));
  if(strcmp(text,"\0")==0){
  g_printf("directories are empty");
  }
  if(strcmp(text_1,"\0")==0){
  g_printf("max. dir. path empty");
  }
  if(strcmp(text_2,"\0")==0){
  g_printf("time is empty");
  }

  g_print ("dir:%s",text);
  int cnt=0,tmp_cnt=0;
  char tmp_dir[100];
  if(strlen(text)>1){
  g_printf("directories are NOT empty");
  while(text[cnt]){
  if(text[cnt] == ',')
  {
  tmp_dir[tmp_cnt]='\0';
  gtk_add_directory(tmp_dir);
  tmp_cnt=0;cnt++;
  }
  tmp_dir[tmp_cnt]=text[cnt];
  tmp_cnt++;cnt++;
  }
  
  tmp_dir[tmp_cnt]='\0';
  gtk_add_directory(tmp_dir);
  }
  g_print ("Max.dir.depth:%s",text_1);
  if(strlen(text_1)>=1)
  max_dir_depth(text_1);
  g_print ("Time:%s",text_2);
  if(strlen(text_2)>=1)
  time_change(text_2);
  system("./install_giis.sh  1");

  gtk_widget_destroy (GTK_WIDGET (assistant));
}

//add directories  to .conf file
gtk_add_directory(char dir_name[100]){
char b[]="$DIR = home$";
char a[4096],d[4096];
char c[100]="$DIR = home$\n";
int i,j,k,tfp,l,m=0;
int arg;
memset(d,'\0',4096);
i=0;arg=1;

strcat(strcat(strcat (c,"$DIR = "),dir_name),"$");
printf("%s",c);
tfp=open(GIIS_CONF_FILE,0);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
exit(0);
}
//read the file
i=read(tfp,a,4096);
close(tfp);

i=0;l=0;
while(a[i]!='\0'){
j=0;
k=i;

	while((b[j]==a[k]) && (b[j]!='\0')){
		j++;
		k++;
		}
	
	if(b[j]=='\0'){
		i=k;
	m=0;
		while(c[m]!='\0'){
			d[l]=c[m];
			m++;
			l++;
	}
	}
	else{
	d[l]=a[i];
	i++;
	l++;
	}
	
}

//Search Ends

//write it
tfp=open(GIIS_CONF_FILE,1);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
exit(0);
}
//read the file
i=write(tfp,d,4096);
close(tfp);


}

// ends


//update max. directory depth
void max_dir_depth(char depth[2]){
char b[]="$LEVEL_VALUE = ";
char a[4096],d[4096];
char c[100]="$LEVEL_VALUE = ";
int i,j,k,tfp,l,m=0;


i=0;
memset(d,'\0',4096);
strcat(strcat(c,depth),"$\n");


tfp=open(GIIS_CONF_FILE,0);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
exit(0);
}
//read the file
i=read(tfp,a,4096);
close(tfp);

i=0;l=0;
while(a[i]!='\0'){
j=0;
k=i;

	while((b[j]==a[k]) && (b[j]!='\0')){
		j++;
		k++;
		}
	
	if(b[j]=='\0'){
	    
		i=k+3;
	m=0;
		while(c[m]!='\0'){
			d[l]=c[m];
			m++;
			l++;
	}
	}
	else{
	d[l]=a[i];
	i++;
	l++;
	}
	
}

//Search Ends
//write it
tfp=open(GIIS_CONF_FILE,1);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
exit(0);
}
//read the file
i=write(tfp,d,4096);
close(tfp);
}

//end max. dir depth
//update time in giis.conf file
void time_change(char time[2]){
char b[]="$TIME = ";
char a[4096],d[4096];
char c[100]="$TIME = ";
int i,j,k,tfp,l,m=0;


i=0;
memset(d,'\0',4096);
strcat(strcat(c,time),"$");

tfp=open(GIIS_CONF_FILE,0);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
exit(0);
}
//read the file
i=read(tfp,a,4096);
close(tfp);

i=0;l=0;
while(a[i]!='\0'){
j=0;
k=i;

	while((b[j]==a[k]) && (b[j]!='\0')){
		j++;
		k++;
		}
	
	if(b[j]=='\0'){
	    
		i=k+3;
	m=0;
		while(c[m]!='\0'){
			d[l]=c[m];
			m++;
			l++;
	}
	}
	else{
	d[l]=a[i];
	i++;
	l++;
	}
	
}
//Search Ends
//write it
tfp=open(GIIS_CONF_FILE,1);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
exit(0);
}
//read the file
i=write(tfp,d,4096);
close(tfp);
}
//end - update time in .conf file

